<?php
    // if a form was submitted
    if($_SERVER["REQUEST_METHOD"] == "POST") {
        // form was submitted
        $isFormSubmitted = true;
        $anyErrors = false;

        // code to connect to database
        $conn = new mysqli("localhost", "root", "", "backend_tutorial");

        if($conn->connect_error) {
            die("Connection failed: ".$e->getMessage());
        }

        $allInputSupplied = false;

        if(isset($_POST["email"]) && !empty($_POST["email"])) {

            $email = $_POST["email"];

            if(filter_var($email, FILTER_VALIDATE_EMAIL)) {
                $email = htmlspecialchars(($_POST["email"]));
                $email = $conn->real_escape_string($email);

                $allInputSupplied = true;

                
            } else {
                $allInputSupplied = false;
            }
        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if(isset($_POST["password"]) && !empty($_POST["password"])) {
            $password = htmlspecialchars(($_POST["password"]));
            $password = $conn->real_escape_string($password);

            $allInputSupplied = true;

        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if($allInputSupplied == true) {

            $sql = "SELECT * FROM users WHERE email='$email'";

            // execute the query
            $result = $conn->query($sql);
            $numRows = $result->num_rows;

            if($numRows > 0) {
                

                $user = $result->fetch_assoc();

                if(password_verify($password, $user["password"])) {
                    //echo "account exists!";

                    $anyErrors = false;

                    $cookie_name = "user_id";
                    $cookie_value = $user["id"];

                    $expire_time = time() + (86400 * 1); // 86400 seconds = 1 day

                    setcookie($cookie_name, $cookie_value, $expire_time, "/");

                    header("Location: users/index.php");

                    exit;
                } else {
                    //echo "account not found";

                    $anyErrors = true;
                }

                
            } else {
                $anyErrors = true;
            }
        }
    } else {
        $isFormSubmitted = false;
        $anyErrors = false;
    }

?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>E-Library</title>

    <link href="assets/bootstrap-5.3.3/css/bootstrap.min.css" rel="stylesheet" type="text/css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <nav class="navbar navbar-expand-lg bg-body-tertiary">
                    <div class="container-fluid">
                        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarTogglerDemo03" aria-controls="navbarTogglerDemo03" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                        </button>
                        <a class="navbar-brand" href="#">E-Library</a>
                        <div class="collapse navbar-collapse" id="navbarTogglerDemo03">
                        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                            <li class="nav-item">
                            <a class="nav-link" aria-current="page" href="index.php">Home</a>
                            </li>
                            <li class="nav-item">
                            <a class="nav-link" href="register.php">Sign Up</a>
                            </li>
                            <li class="nav-item">
                            <a class="nav-link active" href="login.php">Login</a>
                            </li>
                        </ul>
                        </div>
                    </div>
                </nav>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12 text-center">
                <h1>Login to your account</h1>

                <?php
                    if($isFormSubmitted == true && $anyErrors == true) {
                        echo "<div class='alert alert-danger'>Account not found</div>";
                    }

                    /*if($isFormSubmitted == true && $anyErrors == false && $allInputSupplied == true) {
                        echo "<div class='alert alert-success'>You have successfully logged in</div>";
                    }*/
                ?>
            </div>

            <div class="col-md-4"></div>
            <div class="col-md-4">
                <form method="POST" action="login.php">
                    <div class="mb-3">
                        <label for="email" class="form-label">Email</label>
                        <input 
                            type="email" 
                            class="form-control" 
                            name="email" 
                            id="email" 
                            placeholder="name@example.com" 
                            value="<?php if($isFormSubmitted == true) echo $_POST["email"]; ?>"
                        >
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["email"])) {
                                echo "<div class='alert alert-danger'>Please enter your email address</div>";
                            } else {
                                if(!filter_var($email, FILTER_VALIDATE_EMAIL)) {
                                    echo "<div class='alert alert-danger'>Please enter a valid email address</div>";
                                }
                            }
                        }
                    ?>

                    <div class="mb-3">
                        <label for="password" class="form-label">Password</label>
                        <input type="password" name="password" class="form-control" id="password">
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["password"])) {
                                echo "<div class='alert alert-danger'>Please enter your password</div>";
                            }
                        }
                    ?>
                    
                    <div class="mb-3 text-center">
                        <button type="submit" class="btn btn-primary" name="submit">Submit</button>
                    </div>
                </form>
            </div>
            <div class="col-md-4"></div>
        </div>
    </div>

    <script src="assets/js/jquery-3.7.1.min.js"></script>
    <script src="assets/bootstrap-5.3.3/js/popper.min.js"></script>
    <script src="assets/bootstrap-5.3.3/js/bootstrap.min.js"></script>
</body>
</html>