<?php
    // if a form was submitted
    if($_SERVER["REQUEST_METHOD"] == "POST") {
        // form was submitted
        $isFormSubmitted = true;
        $anyErrors = false;

        // code to connect to database
        $conn = new mysqli("localhost", "root", "", "backend_tutorial");

        if($conn->connect_error) {
            die("Connection failed: ".$e->getMessage());
        }

        $allInputSupplied = false;

        if(isset($_POST["firstname"]) && !empty($_POST["firstname"])) {
            $firstname = htmlspecialchars(($_POST["firstname"]));
            $firstname = $conn->real_escape_string($firstname);

            $allInputSupplied = true;
        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if(isset($_POST["lastname"]) && !empty($_POST["lastname"])) {
            $lastname = htmlspecialchars(($_POST["lastname"]));
            $lastname = $conn->real_escape_string($lastname);

            $allInputSupplied = true;
        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if(isset($_POST["email"]) && !empty($_POST["email"])) {

            $email = $_POST["email"];

            if(filter_var($email, FILTER_VALIDATE_EMAIL)) {
                $email = htmlspecialchars(($_POST["email"]));
                $email = $conn->real_escape_string($email);

                $allInputSupplied = true;
            } else {
                $allInputSupplied = false;
            }
        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if(isset($_POST["password"]) && !empty($_POST["password"])) {
            $password = htmlspecialchars(($_POST["password"]));
            $password = $conn->real_escape_string($password);

            $hashedPassword = password_hash($password, PASSWORD_BCRYPT);

            $allInputSupplied = true;
        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if($allInputSupplied == true) {

            $createdAt = date("Y-m-d"); // 2024-11-12
            $sql = "INSERT INTO users (firstname, lastname, email, password, created_at) VALUES ('$firstname',
                    '$lastname', '$email', '$hashedPassword', '$createdAt')";

            // execute the query
            $conn->query($sql);
            $affectedRows = $conn->affected_rows;

            if($affectedRows > 0) {
                $anyErrors = false;

                $cookie_name = "user_id";
                $cookie_value = $conn->insert_id;

                $expire_time = time() + (86400 * 1); // 86400 seconds = 1 day

                setcookie($cookie_name, $cookie_value, $expire_time, "/");

                header("Location: users/index.php");

                exit;
            } else {
                $anyErrors = true;
            }
        }
    } else {
        $isFormSubmitted = false;
        $anyErrors = false;
    }

?>



<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>E-Library</title>

    <link href="assets/bootstrap-5.3.3/css/bootstrap.min.css" rel="stylesheet" type="text/css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <nav class="navbar navbar-expand-lg bg-body-tertiary">
                    <div class="container-fluid">
                        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarTogglerDemo03" aria-controls="navbarTogglerDemo03" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                        </button>
                        <a class="navbar-brand" href="#">E-Library</a>
                        <div class="collapse navbar-collapse" id="navbarTogglerDemo03">
                        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                            <li class="nav-item">
                            <a class="nav-link" aria-current="page" href="index.php">Home</a>
                            </li>
                            <li class="nav-item">
                            <a class="nav-link active" href="register.php">Sign Up</a>
                            </li>
                            <li class="nav-item">
                            <a class="nav-link" href="login.php">Login</a>
                            </li>
                        </ul>
                        </div>
                    </div>
                </nav>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12 text-center">
                <h1>Create an Account</h1>

                <?php
                    if($isFormSubmitted == true && $anyErrors == true) {
                        echo "<div class='alert alert-danger'>There was an error in creating your account</div>";
                    }

                    /*if($isFormSubmitted == true && $anyErrors == false && $allInputSupplied == true) {
                        echo "<div class='alert alert-success'>Your account has been successfully created</div>";
                    }*/
                ?>
            </div>

            <div class="col-md-4"></div>
            <div class="col-md-4">
                <form method="POST" action="register.php">
                    <div class="mb-3">
                        <label for="firstname" class="form-label">First Name</label>
                        <input 
                            type="text" 
                            class="form-control" 
                            name="firstname" 
                            id="firstname" 
                            placeholder="John" 
                            value="<?php if($isFormSubmitted == true) echo $_POST["firstname"]; ?>"
                        >
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["firstname"])) {
                                echo "<div class='alert alert-danger'>Please enter your first name</div>";
                            }
                        }
                    ?>

                    <div class="mb-3">
                        <label for="lastname" class="form-label">Last Name</label>
                        <input 
                            type="text" 
                            class="form-control" 
                            name="lastname" 
                            id="lastname" 
                            placeholder="Doe" 
                            value="<?php if($isFormSubmitted == true) echo $_POST["lastname"]; ?>"
                        >
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["lastname"])) {
                                echo "<div class='alert alert-danger'>Please enter your last name</div>";
                            }
                        }
                    ?>

                    <div class="mb-3">
                        <label for="email" class="form-label">Email</label>
                        <input 
                            type="email" 
                            class="form-control" 
                            name="email" 
                            id="email" 
                            placeholder="name@example.com" 
                            value="<?php if($isFormSubmitted == true) echo $_POST["email"]; ?>"
                        >
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["email"])) {
                                echo "<div class='alert alert-danger'>Please enter your email address</div>";
                            } else {
                                if(!filter_var($email, FILTER_VALIDATE_EMAIL)) {
                                    echo "<div class='alert alert-danger'>Please enter a valid email address</div>";
                                }
                            }
                        }
                    ?>

                    <div class="mb-3">
                        <label for="password" class="form-label">Password</label>
                        <input type="password" name="password" class="form-control" id="password">
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["password"])) {
                                echo "<div class='alert alert-danger'>Please enter your password</div>";
                            }
                        }
                    ?>
                    
                    <div class="mb-3 text-center">
                        <button type="submit" class="btn btn-primary" name="submit">Submit</button>
                    </div>
                </form>
            </div>
            <div class="col-md-4"></div>
        </div>
    </div>

    <script src="assets/js/jquery-3.7.1.min.js"></script>
    <script src="assets/bootstrap-5.3.3/js/popper.min.js"></script>
    <script src="assets/bootstrap-5.3.3/js/bootstrap.min.js"></script>
</body>
</html>