<?php
    // if user is logged in
    if(isset($_COOKIE["user_id"])) {

        $user_id = $_COOKIE["user_id"];

    } else {
        header("Location: ../login.php");
    }

    if(isset($_REQUEST["book_id"])) {

        // code to connect to database
        $conn = new mysqli("localhost", "root", "", "backend_tutorial");

        if($conn->connect_error) {
            die("Connection failed: ".$e->getMessage());
        }

        $bookId = $_REQUEST["book_id"];

        $sql = "SELECT * FROM books WHERE id='$bookId' AND user_id='$user_id'";

        $result = $conn->query($sql);
        $numRows = $result->num_rows;

        if($numRows > 0) {
            while($row = $result->fetch_assoc()) {
                $books[] = $row;
            }

            foreach($books as $book) {
                $bookTitle = $book["title"];
                $bookAuthor = $book["author"];
                $bookCreatedAt = $book["created_at"];
                $bookId = $book["id"];
            }
        } else {
            session_start();

            $_SESSION["error_flash_message"] = "The book does not exist!";

            header("Location: view_books.php");

            exit;
        }

    } else {
        header("Location: ../login.php");
    }

    // if a form was submitted
    if($_SERVER["REQUEST_METHOD"] == "POST") {
        // form was submitted
        $isFormSubmitted = true;
        $anyErrors = false;

        // code to connect to database
        $conn = new mysqli("localhost", "root", "", "backend_tutorial");

        if($conn->connect_error) {
            die("Connection failed: ".$e->getMessage());
        }

        $allInputSupplied = false;

        if(isset($_POST["title"]) && !empty($_POST["title"])) {
            $title = htmlspecialchars(($_POST["title"]));
            $title = $conn->real_escape_string($title);

            $allInputSupplied = true;
        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if(isset($_POST["author"]) && !empty($_POST["author"])) {
            $author = htmlspecialchars(($_POST["author"]));
            $author = $conn->real_escape_string($author);

            $allInputSupplied = true;
        } else {
            // notfiy users to supply it
            $allInputSupplied = false;
        }

        if($allInputSupplied == true) {

            $createdAt = date("Y-m-d"); // 2024-11-12
            $sql = "UPDATE books SET title='$title', author='$author' WHERE id='$bookId' AND user_id='$user_id'";

            // execute the query
            $conn->query($sql);
            $affectedRows = $conn->affected_rows;

            if($affectedRows > 0) {
                $anyErrors = false;

                session_start();

                $_SESSION["success_flash_message"] = "Book updated successfully";

                header("Location: view_books.php");

                exit;
            } else {
                $anyErrors = true;
            }
        }
    } else {
        $isFormSubmitted = false;
        $anyErrors = false;
    }

?>



<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>E-Library</title>

    <link href="../assets/bootstrap-5.3.3/css/bootstrap.min.css" rel="stylesheet" type="text/css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <nav class="navbar navbar-expand-lg bg-body-tertiary">
                <div class="container-fluid">
                        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarTogglerDemo03" aria-controls="navbarTogglerDemo03" aria-expanded="false" aria-label="Toggle navigation">
                            <span class="navbar-toggler-icon"></span>
                        </button>
                        <a class="navbar-brand" href="#">E-Library</a>
                        <div class="collapse navbar-collapse" id="navbarTogglerDemo03">
                            <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                                <li class="nav-item">
                                    <a class="nav-link" aria-current="page" href="index.php">Home</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" href="view_books.php">View Books</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" href="add_book.php">Add Book</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" href="logout.php">Logout</a>
                                </li>
                            </ul>
                        </div>
                    </div>
                </nav>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12 text-center">
                <h1>Edit a Book</h1>

                <?php
                    if($isFormSubmitted == true && $anyErrors == true) {
                        echo "<div class='alert alert-danger'>There was an error in updated the book</div>";
                    }

                    /*if($isFormSubmitted == true && $anyErrors == false && $allInputSupplied == true) {
                        echo "<div class='alert alert-success'>Your account has been successfully created</div>";
                    }*/
                ?>
            </div>

            <div class="col-md-4"></div>
            <div class="col-md-4">
                <form method="POST" action="edit_book.php?book_id=<?php echo $bookId; ?>">
                    <div class="mb-3">
                        <label for="title" class="form-label">Title</label>
                        <input 
                            type="text" 
                            class="form-control" 
                            name="title" 
                            id="title" 
                            placeholder="Introduction to Javascript" 
                            value="<?php echo $bookTitle; ?>"
                        >
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["title"])) {
                                echo "<div class='alert alert-danger'>Please enter the title of the book</div>";
                            }
                        }
                    ?>

                    <div class="mb-3">
                        <label for="author" class="form-label">Author</label>
                        <input 
                            type="text" 
                            class="form-control" 
                            name="author" 
                            id="author" 
                            placeholder="John Doe" 
                            value="<?php echo $bookAuthor; ?>"
                        >
                    </div>

                    <?php
                        if($isFormSubmitted == true) {
                            if(empty($_POST["author"])) {
                                echo "<div class='alert alert-danger'>Please enter the author of the book</div>";
                            }
                        }
                    ?>

                    
                    
                    <div class="mb-3 text-center">
                        <button type="submit" class="btn btn-primary" name="submit">Submit</button>
                    </div>
                </form>
            </div>
            <div class="col-md-4"></div>
        </div>
    </div>

    <script src="../assets/js/jquery-3.7.1.min.js"></script>
    <script src="../assets/bootstrap-5.3.3/js/popper.min.js"></script>
    <script src="../assets/bootstrap-5.3.3/js/bootstrap.min.js"></script>
</body>
</html>