<?php
    // if user is logged in
    if(isset($_COOKIE["user_id"])) {

        $user_id = $_COOKIE["user_id"];

        // code to connect to database
        $conn = new mysqli("localhost", "root", "", "backend_tutorial");

        if($conn->connect_error) {
            die("Connection failed: ".$e->getMessage());
        }

        $sql = "SELECT * FROM users WHERE id='$user_id'";

        // execute the query
        $result = $conn->query($sql);
        $numRows = $result->num_rows;

        if($numRows > 0) {
            

            $user = $result->fetch_assoc();

            $records_per_page = 1;

            $current_page = isset($_GET["page"]) && is_numeric($_GET["page"]) ? (int)$_GET["page"] : 1;

            $offset = ($current_page - 1) * $records_per_page;

            $total_records_query = "SELECT COUNT(*) AS total FROM books WHERE user_id='$user_id'";

            $result = $conn->query($total_records_query);
            $row = $result->fetch_assoc();
            $total_records = $row["total"];

            $total_pages = ceil($total_records/$records_per_page);

            // get user's books
            $sql = "SELECT * FROM books WHERE user_id='$user_id' LIMIT $records_per_page OFFSET $offset";

            $result = $conn->query($sql);
            $numRows = $result->num_rows;

            if($numRows > 0) {
                while($row = $result->fetch_assoc()) {
                    $books[] = $row;
                }

                
            } else {
                $books = array();
            }

            
        } else {
            header("Location: ../login.php");
        }
    } else {
        header("Location: ../login.php");
    }

?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>E-Library :: Users</title>

    <link href="../assets/bootstrap-5.3.3/css/bootstrap.min.css" rel="stylesheet" type="text/css">

    <style>
        table {
            width: 100%;
            border-collapse: collapse;
            margin: auto;
        }

        table, th, td {
            border: 1px solid black;
        }

        th, td {
            padding: 8px;
            text-align: left;
        }

        th {
            background-color: #f2f2f2;
        }

        .pagination {
            display: flex;
            justify-content: center;
            align-items: center;
            margin-top: 20px;
            list-style: none;
            padding: 0;
        }

        .pagination a {
            color: #007bff;
            padding: 10px 15px;
            text-decoration: none;
            border: 1px solid #ddd;
            margin: 0.5px;
            border-radius: 4px;
            transition: background-color 0.3s ease;
        }

        .pagination a:active {
            background-color: #007bff;
            color: white;
            border-color: #007bff;
        }

        .pagination a:hover:not(active) {
            background-color: #f1f1f1;
            border-color: #007bff;
        }

        .pagination a.disabled {
            color: #ccc;
            pointer-events: none;
            cursor: not-allowed;
            border-color: #ddd;
        }

        @media (max-width: 600px) {
            .pagination a {
                padding: 8px 12px;
                margin: 2px;
            }
        }
    </style>

</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <nav class="navbar navbar-expand-lg bg-body-tertiary">
                    <div class="container-fluid">
                        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarTogglerDemo03" aria-controls="navbarTogglerDemo03" aria-expanded="false" aria-label="Toggle navigation">
                            <span class="navbar-toggler-icon"></span>
                        </button>
                        <a class="navbar-brand" href="#">E-Library</a>
                        <div class="collapse navbar-collapse" id="navbarTogglerDemo03">
                            <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                                <li class="nav-item">
                                    <a class="nav-link" aria-current="page" href="index.php">Home</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link active" href="view_books.php">View Books</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" href="add_book.php">Add Book</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" href="logout.php">Logout</a>
                                </li>
                            </ul>
                        </div>
                    </div>
                </nav>
            </div>
        </div>

        <div class="row">
            <div class="col-md-2"></div>
            <div class="col-md-8">
                <?php

                    session_start();

                    if(isset(($_SESSION["success_flash_message"]))) {
                        echo "<div class='alert alert-success text-center'><strong>".$_SESSION["success_flash_message"]."</strong></div>";

                        unset($_SESSION["success_flash_message"]);
                    }

                    if(isset(($_SESSION["error_flash_message"]))) {
                        echo "<div class='alert alert-danger text-center'><strong>".$_SESSION["error_flash_message"]."</strong></div>";

                        unset($_SESSION["error_flash_message"]);
                    }
                ?>
                <?php
                    if(count($books) > 0) {

                        $serialNo = $offset + 1;

                        // show books
                        echo "<table>";
                        echo "<tr>
                            <th>S/N</th>
                            <th>Title</th>
                            <th>Author</th>
                            <th>Created On</th>
                            <th>Options</th>
                        </tr>";

                        foreach($books as $book) {
                            $bookTitle = $book["title"];
                            $bookAuthor = $book["author"];
                            $bookCreatedAt = $book["created_at"];
                            $bookId = $book["id"];

                            echo "<tr>
                                <td>$serialNo</td>
                                <td>$bookTitle</td>
                                <td>$bookAuthor</td>
                                <td>$bookCreatedAt</td>
                                <td>
                                    <div><a href='edit_book.php?book_id=$bookId'>Edit</a></div>
                                    <div><a href='delete_book.php?book_id=$bookId' onclick='confirmDelete(event, this.href)'>Delete</a></div>
                                </td>
                            </tr>";

                            $serialNo++;
                        }

                        echo "</table>";

                        echo "<div class='pagination'>";

                        if($current_page > 1) {
                            echo '<a href="view_books.php?page='.($current_page - 1).'">Previous</a>';
                        }

                        for($i = 1; $i < $total_pages; $i++) {
                            echo '<a href="view_books.php?page='.$i.'"';

                            if($i == $current_page) {
                                echo 'class="active"';
                                
                            }

                            echo '>'.$i.'</a>';
                        }

                        if($current_page < $total_pages) {
                            echo '<a href="view_books.php?page='.($current_page + 1).'">Next</a>';
                        }

                        echo '</div>';
                    } else {
                        echo "<div class='alert alert-info text-center'><strong>You currently have no books</strong></div>";
                    }
                ?>
            </div>
            <div class="col-md-2"></div>
        </div>
    </div>

    <script src="../assets/js/jquery-3.7.1.min.js"></script>
    <script src="../assets/bootstrap-5.3.3/js/popper.min.js"></script>
    <script src="../assets/bootstrap-5.3.3/js/bootstrap.min.js"></script>

    <script type="text/javascript">
        function confirmDelete(event, url) {
            event.preventDefault();

            var userConfirm = confirm("Are you sure you want to delete this?");

            if(userConfirm) {
                window.location.href = url;
            }
        }
    </script>
</body>
</html>